var LabEnvAlarm = function()
{
	var labenvalarm = {};
	var debug = 1;

	// Page initialization
	labenvalarm.initPage = function()
	{
		previewTitle = Doc.element('previewTitle');
		previewList = Doc.element('previewList');

		// Step 1

		// Navigation
		Buttons.addClickHandler('gosetalarmblocker', labenvalarm.goSetAlarmBlocker);

		// Create lab environment alarms web page from configuration data
		labenvalarm.createLabEnvAlarmWebPage();

		Doc.show('step-1');
		Doc.show('gosetalarmblocker');
	}

	labenvalarm.createLabEnvAlarmWebPage = function()
	{
		document.getElementById("gosetalarmblocker").style.display = 'block';
		// Get lab sensor configurations JSON object with Ajax
		var url = '../LabEnvironment.servlet?ID='+App.getSessionId();
		url += '&cmd=GetLabSensorConfigList';
		
		Wizard.asyncJsonRequest(url, labenvalarm.createLabEnvAlarmWebPage2);
	}

	labenvalarm.createLabEnvAlarmWebPage2 = function(response)
	{
		Doc.show('navigation');
		if (response.status != 'ok')
		{
			setFatalError(response.message);
			return false;
		}
		// Get sensor configurations information from the Ajax response
		var labSensorConfigList = response.labSensorConfigList;
		if (labSensorConfigList != null)
		{
			var alarmTable = document.getElementById('alarmTableId');
			alarmTable.setAttribute('id', 'alarmTable');
			// Print alarm table header row
			var colspan = 11;
			var alarmTableHeaderClass = 'alarmtableheader';
			var alarmHeaderCell01 = labenvalarm.getTableCellElement('Alarm', alarmTableHeaderClass);
			var alarmHeaderCell02 = labenvalarm.getTableCellElement('Sensor', alarmTableHeaderClass);
			var alarmHeaderCell03 = labenvalarm.getTableCellElement('Start', alarmTableHeaderClass);
			var alarmHeaderCell04 = labenvalarm.getTableCellElement('End', alarmTableHeaderClass);
			var alarmHeaderCell05 = labenvalarm.getTableCellElement('Weekday', alarmTableHeaderClass);
			var alarmHeaderCell06 = labenvalarm.getTableCellElement('Temp.', alarmTableHeaderClass);
			var alarmHeaderCell07 = labenvalarm.getTableCellElement('Temp.', alarmTableHeaderClass);
			var alarmHeaderCell08 = labenvalarm.getTableCellElement('Humidity', alarmTableHeaderClass);
			var alarmHeaderCell09 = labenvalarm.getTableCellElement('Humidity', alarmTableHeaderClass);
			var alarmHeaderCell10 = labenvalarm.getTableCellElement('Alarm', alarmTableHeaderClass);
			var alarmHeaderCell11 = labenvalarm.getTableCellElement('Alarm', alarmTableHeaderClass);
			var alarmHeaderRow = document.createElement('tr');
			alarmHeaderRow.appendChild(alarmHeaderCell01);			
			alarmHeaderRow.appendChild(alarmHeaderCell02);			
			alarmHeaderRow.appendChild(alarmHeaderCell03);			
			alarmHeaderRow.appendChild(alarmHeaderCell04);			
			alarmHeaderRow.appendChild(alarmHeaderCell05);
			alarmHeaderRow.appendChild(alarmHeaderCell06);			
			alarmHeaderRow.appendChild(alarmHeaderCell07);			
			alarmHeaderRow.appendChild(alarmHeaderCell08);			
			alarmHeaderRow.appendChild(alarmHeaderCell09);			
			alarmHeaderRow.appendChild(alarmHeaderCell10);			
			alarmHeaderRow.appendChild(alarmHeaderCell11);			
			alarmTable.appendChild(alarmHeaderRow);
			var alarmTableSubHeaderClass = 'reportsubheader';
			var alarmTableSubHeaderClass = 'alarmtableheader';
			var alarmSubHeaderCell01 = labenvalarm.getTableCellElement('no', alarmTableSubHeaderClass);
			var alarmSubHeaderCell02 = labenvalarm.getTableCellElement('name', alarmTableSubHeaderClass);
			var alarmSubHeaderCell03 = labenvalarm.getTableCellElement('time', alarmTableSubHeaderClass);
			var alarmSubHeaderCell04 = labenvalarm.getTableCellElement('time', alarmTableSubHeaderClass);
			var alarmSubHeaderCell05 = labenvalarm.getTableCellElement('filter', alarmTableSubHeaderClass);
			var alarmSubHeaderCell06 = labenvalarm.getTableCellElement('min', alarmTableSubHeaderClass);
			var alarmSubHeaderCell07 = labenvalarm.getTableCellElement('max', alarmTableSubHeaderClass);
			var alarmSubHeaderCell08 = labenvalarm.getTableCellElement('min', alarmTableSubHeaderClass);
			var alarmSubHeaderCell09 = labenvalarm.getTableCellElement('max', alarmTableSubHeaderClass);
			var alarmSubHeaderCell10 = labenvalarm.getTableCellElement('blocked', alarmTableSubHeaderClass);
			var alarmSubHeaderCell11 = labenvalarm.getTableCellElement('text', alarmTableSubHeaderClass);
			var alarmSubHeaderRow = document.createElement('tr');
			alarmSubHeaderRow.appendChild(alarmSubHeaderCell01);
			alarmSubHeaderRow.appendChild(alarmSubHeaderCell02);
			alarmSubHeaderRow.appendChild(alarmSubHeaderCell03);
			alarmSubHeaderRow.appendChild(alarmSubHeaderCell04);
			alarmSubHeaderRow.appendChild(alarmSubHeaderCell05);
			alarmSubHeaderRow.appendChild(alarmSubHeaderCell06);
			alarmSubHeaderRow.appendChild(alarmSubHeaderCell07);
			alarmSubHeaderRow.appendChild(alarmSubHeaderCell08);
			alarmSubHeaderRow.appendChild(alarmSubHeaderCell09);
			alarmSubHeaderRow.appendChild(alarmSubHeaderCell10);
			alarmSubHeaderRow.appendChild(alarmSubHeaderCell11);
			alarmTable.appendChild(alarmSubHeaderRow);
			for (var i=0; i < labSensorConfigList.length; i++)
			{
				// Get URL and name for lab sensor number 'i'
				var labSensorConfig = labSensorConfigList[i];
				var sensorUrl = labSensorConfig['url'];
				var sensorName = labSensorConfig['name'];
				//alert("i = " + i + " sensorUrl = " + sensorUrl + " sensorName = " + sensorName);
				var alarmList = labSensorConfig['alarmList'];
				//alert("i = " + i + " alarmList = " + alarmList);
				if (alarmList != null)
				{
					//alert("i = " + i + " alarmList.length = " + alarmList.length);
					for (var j=0; j < alarmList.length; j++)
					{
						// Get alarm number 'j'
						var alarm = alarmList[j];
						var alarmNo = alarm['no'];
						var startTime = alarm['startTime'];
						var endTime = alarm['endTime'];
						var weekdayFilter = alarm['weekdayFilter'];
						var temperatureMin = alarm['temperatureMin'];
						var temperatureMax = alarm['temperatureMax'];
						var humidityMin = alarm['humidityMin'];
						var humidityMax = alarm['humidityMax'];
						var alarmBlocked = alarm['alarmBlocked'];
						var alarmText = alarm['alarmText'];
						var alarmPermission = alarm['alarmPermission'];
						if (alarmPermission != null && alarmPermission)
						{
							anyAlarmPermission = true;
						}
						if (alarmBlocked == null)
						{
							alarmBlocked = false;
						}
						if (alarmText == null)
						{
							alarmText = '-';
						}
						//alert("createLabEnvAlarmWebPage(): i = " + i + " j = " + j + " sensorName = " + sensorName + " startTime = " + startTime  + " endTime = " + endTime + " weekdayFilter = " + weekdayFilter + " temperatureMin = " + temperatureMin + " temperatureMax = " + temperatureMax + " humidityMin = " + humidityMin + " humidityMax = " + humidityMax + " alarmBlocked = " + alarmBlocked + " alarmText = " + alarmText);
						var alarmRowText = alarmNo + '\n' + sensorName + '\n' + startTime + '\n'  + endTime + '\n' + weekdayFilter + '\n' + temperatureMin + '\n' + temperatureMax + '\n' + humidityMin + '\n' + humidityMax + '\n' + alarmBlocked + '\n' + alarmText;
						//alert("alarmRowText = " + alarmRowText);
						var alarmRow = document.createElement('tr');
						//var alarmTableClass = 'reportheader';
						var alarmTableClass = 'reportdata';
						var alarmCell01 = labenvalarm.getTableCellElement(alarmNo, alarmTableClass);
						var alarmCell02 = labenvalarm.getTableCellElement(sensorName, alarmTableClass);
						var alarmCell03 = labenvalarm.getTableCellElement(startTime, alarmTableClass);
						var alarmCell04 = labenvalarm.getTableCellElement(endTime, alarmTableClass);
						var alarmCell05 = labenvalarm.getTableCellElement(weekdayFilter, alarmTableClass);
						var alarmCell06 = labenvalarm.getTableCellElement(temperatureMin, alarmTableClass);
						var alarmCell07 = labenvalarm.getTableCellElement(temperatureMax, alarmTableClass);
						var alarmCell08 = labenvalarm.getTableCellElement(humidityMin, alarmTableClass);
						var alarmCell09 = labenvalarm.getTableCellElement(humidityMax, alarmTableClass);
						var alarmCell10 = labenvalarm.getTableCellYesNoSelectElement(alarmBlocked, 'alarmBlockedId' + alarmNo, alarmPermission, alarmTableClass);
						var alarmCell11 = labenvalarm.getTableCellElement(alarmText, alarmTableClass);
						alarmRow.appendChild(alarmCell01);
						alarmRow.appendChild(alarmCell02);
						alarmRow.appendChild(alarmCell03);
						alarmRow.appendChild(alarmCell04);
						alarmRow.appendChild(alarmCell05);
						alarmRow.appendChild(alarmCell06);
						alarmRow.appendChild(alarmCell07);
						alarmRow.appendChild(alarmCell08);
						alarmRow.appendChild(alarmCell09);
						alarmRow.appendChild(alarmCell10);
						alarmRow.appendChild(alarmCell11);
						alarmTable.appendChild(alarmRow);
					}
				}
			}
		}
		if (!anyAlarmPermission)
		{
			// Hide "Set alarm blocker" button if logged-in user does not have permission to set any alarm blocker status
			document.getElementById("gosetalarmblocker").style.display = 'none';
		}
	}

	labenvalarm.goSetAlarmBlocker = function()
	{
		// Set alarm blocked flags with AJAX
		// Get lab sensor configurations JSON object with Ajax
		var url = '../LabEnvironment.servlet?ID='+App.getSessionId();
		url += '&cmd=GetLabSensorConfigList';

		Wizard.showLoadingAnimation('Working...');
		Doc.hide('navigation');
		Wizard.asyncJsonRequest(url, labenvalarm.goSetAlarmBlocker2);
	}

	labenvalarm.goSetAlarmBlocker2 = function(response)
	{
		Doc.show('navigation');
		if (response.status != 'ok')
		{
			setFatalError(response.message);
			return false;
		}
		var request = Ajax.getXmlHttpRequest();
		var url = '../LabEnvironment.servlet?ID='+App.getSessionId();
		url += '&cmd=SetLabEnvAlarmConfig';

		// Get sensor configurations information from the Ajax response
		var labSensorConfigList = response.labSensorConfigList;
		if (labSensorConfigList != null)
		{
			for (var i=0; i < labSensorConfigList.length; i++)
			{
				// Get URL and name for lab sensor number 'i'
				var labSensorConfig = labSensorConfigList[i];
				var alarmList = labSensorConfig['alarmList'];
				//alert("i = " + i + " alarmList = " + alarmList);
				if (alarmList != null)
				{
					//alert("i = " + i + " alarmList.length = " + alarmList.length);
					for (var j=0; j < alarmList.length; j++)
					{
						// Get alarm number 'j'
						var alarm = alarmList[j];
						var alarmNo = alarm['no'];
						// Get value for alarm blocker option menu
						var alarmBlockedMenuId = 'alarmBlockedId' + alarmNo;
						var selectEl = document.getElementById(alarmBlockedMenuId);
						//alert("alarmNo = " + alarmNo + " alarmBlockedMenuId = " + alarmBlockedMenuId + " selectEl = " + selectEl);
						if (selectEl != null)
						{
							var selectValue = selectEl.value;
							//alert("alarmNo = " + alarmNo + " alarmBlockedMenuId = " + alarmBlockedMenuId + " value = " + selectValue);
							if (selectValue == null)
							{
								selectValue = false;
							}
							// Add alarm block value to Ajax URL
							url += '&' + alarmBlockedMenuId + '=' + selectValue;
						}
					}
				}
			}
		}

		Wizard.asyncJsonRequest(url, labenvalarm.goSetAlarmBlocker3);
	}

	labenvalarm.goSetAlarmBlocker3 = function(response)
	{
		Doc.show('navigation');
		if (response.status != 'ok')
		{
			setFatalError(response.message);
			return false;
		}
	}

	labenvalarm.getTableCellElement = function(text, clazz, colspan, rowspan)
	{
		var cellElement = document.createElement('td');
		text = new String(text);		
		var textArray = text.split("\n");		
		if (textArray.length > 1)
		{	
			for (var i=0;i<textArray.length;i++)
			{				
				if (i>0)cellElement.appendChild(document.createElement('br'));
				cellElement.appendChild(document.createTextNode(textArray[i]));
			}			
		}
		else
		{
			cellElement.appendChild(document.createTextNode(text));
		}
		cellElement.setAttribute('class', clazz);
		if (colspan != null) cellElement.setAttribute('colspan', colspan);
		if (rowspan != null) cellElement.setAttribute('rowspan', rowspan);
		
		return cellElement;
	}

	labenvalarm.getTableCellYesNoSelectElement = function(value, id, permission, clazz, colspan, rowspan)
	{
		var cellElement = document.createElement('td');
		var selectElement = document.createElement('select');
		selectElement.setAttribute('id', id);
		selectElement.setAttribute('name', id);
		if (permission == null || !permission)
		{
			selectElement.setAttribute('disabled', true);
		}
		// Create and add new option elements to select menu
		var optionYesEl = document.createElement('option');
		optionYesEl.setAttribute('value', true);
		optionYesEl.innerHTML = 'Yes';
		if (value != null && value)
		{
			optionYesEl.setAttribute('selected','yes');
		}
		var optionNoEl = document.createElement('option');
		optionNoEl.setAttribute('value', false);
		optionNoEl.innerHTML = 'No';
		if (value == null || !value)
		{
			optionNoEl.setAttribute('selected','yes');
		}
		selectElement.appendChild(optionYesEl);
		selectElement.appendChild(optionNoEl);
		cellElement.appendChild(selectElement);
		cellElement.setAttribute('class', 'input');
		cellElement.setAttribute('align', 'center');
		cellElement.setAttribute('text-align', 'center');
		cellElement.setAttribute('class', clazz);
		if (colspan != null) cellElement.setAttribute('colspan', colspan);
		if (rowspan != null) cellElement.setAttribute('rowspan', rowspan);
		
		return cellElement;
	}

	labenvalarm.goPrint = function()
	{
		var printNote = '<b>Note!</b> For better printing set page orientation to <i>portrait</i>.';
		printNote += ' Scale down to <i>90%</i> to fit 2 plots per page.';
		openPrintWindow('<%=ID%>', 'reportcell', 'Lab environment statistics', 'portrait', printNote, '../');
	}

	return labenvalarm;
}();

Doc.onLoad(LabEnvAlarm.initPage);