var LabEnvDbStat = function()
{
	var labenvdbstat = {};
	var debug = 0;

	// Page initialization
	labenvdbstat.initPage = function()
	{
		var frm = document.forms['labenv'];

		// Step 1

		// Step 2
		Events.addEventHandler('step-2', 'wizard-initialize', labenvdbstat.initializeStep2);
		Events.addEventHandler('step-2', 'wizard-validate', labenvdbstat.validateStep2);
		Events.addEventHandler('fromdate', 'blur', labenvdbstat.fromDateTimeOnChange);
		Events.addEventHandler('fromtime', 'blur', labenvdbstat.fromDateTimeOnChange);
		Events.addEventHandler('todate', 'blur', labenvdbstat.toDateTimeOnChange);
		Events.addEventHandler('totime', 'blur', labenvdbstat.toDateTimeOnChange);
		
		// Step 3
		Events.addEventHandler('printButton', 'click', labenvdbstat.printVersion);
		
		// Navigation
		Buttons.addClickHandler('gocancel', Wizard.cancelWizard);
		Buttons.addClickHandler('gorestart', Wizard.restartWizard);
		Buttons.addClickHandler('gonext', Wizard.goNextOnClick);
		Buttons.addClickHandler('gocreate', Wizard.goRegister);
	
		// Final registration
		Events.addEventHandler('wizard', 'wizard-submit', labenvdbstat.submit);
		Events.addEventHandler('printButton', 'click', labenvdbstat.printVersion);
	
		Doc.show('step-1');
		Doc.show('gonext');

		// Create lab sensor menu from configuration data
		labenvdbstat.createSensorMenu();
	}

	labenvdbstat.createSensorMenu = function()
	{
		// Get lab sensor configurations JSON object with AJAX
		var request = Ajax.getXmlHttpRequest();
		var url = '../LabEnvironment.servlet?ID='+App.getSessionId();
		url += '&cmd=GetLabSensorConfigList';

		Wizard.asyncJsonRequest(url, labenvdbstat.createSensorMenu2);
	}

	labenvdbstat.createSensorMenu2 = function(response)
	{
		Doc.show('navigation');
		if (response.status != 'ok')
		{
			setFatalError(response.message);
			return false;
		}
		// Get sensor configurations information from the AJAX response
		var labSensorConfigList = response.labSensorConfigList;
		if (labSensorConfigList != null)
		{
			// Construct lab sensor menu from JSON data
			var sensorSelect = document.getElementById('sensorSelectId');
			for (var i=0; i < labSensorConfigList.length; i++)
			{
				// Get URL and name for lab sensor number 'i'
				var labSensorConfig = labSensorConfigList[i];
				var sensorUrl = labSensorConfig['url'];
				var sensorName = labSensorConfig['name'];
				// Create and add new option element to select menu
				var optionEl = document.createElement('option');
				optionEl.setAttribute('value',sensorUrl);
				optionEl.innerHTML = sensorName;
				sensorSelect.appendChild(optionEl);
			}
		}
	}

	labenvdbstat.initializeStep2 = function()
	{
		Wizard.setCurrentStep(2);
		var frm = document.forms['labenv'];
		frm.reporttype.disabled = true;
		// Hide report period input fields
		document.getElementById("reportPeriodSubSection01").style.display = 'none';
		document.getElementById("reportPeriodSubSection02").style.display = 'none';
		document.getElementById("reportPeriodSubSection04").style.display = 'none';
		// Hide view type pop-up menu
		document.getElementById("viewTypeSubSection01").style.display = 'none';
		document.getElementById("viewTypeSubSection02").style.display = 'none';
		document.getElementById("viewTypeSubSection04").style.display = 'none';
		// Hide day-time filter input fields
		document.getElementById("dayTimeFilterSubSection01").style.display = 'none';
		document.getElementById("dayTimeFilterSubSection02").style.display = 'none';
		document.getElementById("dayTimeFilterSubSection04").style.display = 'none';
		// Hide weekday filter pop-up menu
		document.getElementById("weekDayFilterSubSection01").style.display = 'none';
		document.getElementById("weekDayFilterSubSection02").style.display = 'none';
		document.getElementById("weekDayFilterSubSection04").style.display = 'none';
		// Hide chart variant pop-up menu
		document.getElementById("chartVariantSubSection01").style.display = 'none';
		document.getElementById("chartVariantSubSection02").style.display = 'none';
		document.getElementById("chartVariantSubSection04").style.display = 'none';
		if (frm.reporttype.value == 'labenvironmentdailydistribution'
			|| frm.reporttype.value == 'labenvironmentweeklydistribution')
		{
			// Show report period input fields
			document.getElementById("reportPeriodSubSection01").style.display = 'block';
			document.getElementById("reportPeriodSubSection02").style.display = 'block';
			document.getElementById("reportPeriodSubSection04").style.display = 'block';
			document.getElementById("reportPeriodSubSection01Header").innerHTML="From";
			document.getElementById("reportPeriodSubSection04HelpText").innerHTML="Start date+time (YYYYMMDD, HHMM) Blank fields give data from start.";
			// Show view type pop-up menu
			document.getElementById("viewTypeSubSection01").style.display = 'block';
			document.getElementById("viewTypeSubSection02").style.display = 'block';
			document.getElementById("viewTypeSubSection04").style.display = 'block';
		}
		if (frm.reporttype.value == 'labenvironmentdailydistribution'
			|| frm.reporttype.value == 'labenvironmentweeklydistribution')
		{
			// Show weekday filter pop-up menu
			document.getElementById("weekDayFilterSubSection01").style.display = 'block';
			document.getElementById("weekDayFilterSubSection02").style.display = 'block';
			document.getElementById("weekDayFilterSubSection04").style.display = 'block';
		}
		if (frm.reporttype.value == 'labenvironmentweeklydistribution')
		{
			// Show day-time filter input fields
			document.getElementById("dayTimeFilterSubSection01").style.display = 'block';
			document.getElementById("dayTimeFilterSubSection02").style.display = 'block';
			document.getElementById("dayTimeFilterSubSection04").style.display = 'block';
		}
		if (frm.reporttype.value == 'labenvironmentdailydistribution'
			|| frm.reporttype.value == 'labenvironmentweeklydistribution')
		{
			// Show chart data pop-up menu
			document.getElementById("chartVariantSubSection01").style.display = 'block';
			document.getElementById("chartVariantSubSection02").style.display = 'block';
			document.getElementById("chartVariantSubSection04").style.display = 'block';
		}
		Doc.show('parameterSection');
				
		Doc.show('step-2');
		Doc.show('gocreate');		
		Doc.hide('gonext');

		frm.fromdate.focus();
	}

	labenvdbstat.validateStep2 = function(event)
	{
		labenvdbstat.dateOnChange();
		//if (!periodIsValid) event.preventDefault();
	}
	
	labenvdbstat.addEventHandlers = function(elements, eventName, handler)
	{
		for (var i = 0; i < elements.length; i++)
		{
			Events.addEventHandler(elements[i], eventName, handler);
		}
	}

	labenvdbstat.fromDateTimeOnChange = function()
	{
		var frm = document.forms['labenv'];
		var todaysDate = new Date();
		fromDateIsValid = false;
		Wizard.setInputStatus('fromdate', '', '');
	
		var fromDate = frm.fromdate.value;
		var fromTime = frm.fromtime.value;
	
		if (fromDate != '' || fromTime != '')
		{
			// Auto-fill the date if it's only given with 4(MMdd) or 6(yyMMdd) digits.
			fromDate = autoFillDate(fromDate);
			frm.fromdate.value = fromDate;

			fromTime = autoFillTime(fromTime);
			frm.fromtime.value = fromTime;
		
			if (!Dates.isDate(fromDate, 'yyyyMMdd'))
			{
				Wizard.setInputStatus('fromdate', 'Not a valid date', 'invalid');
				return;
			}		
		
			if (!Dates.isDate(fromDate + ' ' + fromTime, 'yyyyMMdd HHmm'))
			{
				if (fromDate != '') Wizard.setInputStatus('fromdate', 'Not a valid time (if time unknown, also leave date field blank)', 'invalid');
				return;
			}
			Wizard.setInputStatus('fromdate', '', 'valid');
		}
		fromDateIsValid = true;
		labenvdbstat.toDateTimeOnChange();
	}

	labenvdbstat.toDateTimeOnChange = function()
	{
		var frm = document.forms['labenv'];
		var todaysDate = new Date();
		toDateIsValid = false;
		Wizard.setInputStatus('toDate', '', '');
	
		var toDate = frm.todate.value;
		var toTime = frm.totime.value;
	
		if (toDate != '' || toTime != '')
		{
			// Auto-fill the date if it's only given with 4(MMdd) or 6(yyMMdd) digits.
			toDate = autoFillDate(toDate);
			frm.todate.value = toDate;

			toTime = autoFillTime(toTime);
			frm.totime.value = toTime;
		
			if (!Dates.isDate(toDate, 'yyyyMMdd'))
			{
				Wizard.setInputStatus('todate', 'Not a valid date', 'invalid');
				return;
			}		
		
			if (!Dates.isDate(toDate + ' ' + toTime, 'yyyyMMdd HHmm'))
			{
				if (toDate != '') Wizard.setInputStatus('todate', 'Not a valid time (if time unknown, also leave date field blank)', 'invalid');
				return;
			}
			Wizard.setInputStatus('todate', '', 'valid');
		}
		toDateIsValid = true;
	}
	
	var intervalIsValid = true;

	labenvdbstat.dateOnChange = function()
	{
		var frm = document.forms['labenv'];		
		var fdate;
		var tdate;
		
		intervalIsValid = false;
		Wizard.setInputStatus('displayInterval','','valid');
		if (frm.fromdate.value != null && frm.fromdate.value != '')
		{
			frm.fromdate.value = autoFillDate(frm.fromdate.value);			
			if (!Dates.isDate(frm.fromdate.value, 'yyyyMMdd'))
			{
				Wizard.setInputStatus('displayInterval','Not a valid from-date', 'invalid');
				return;
			}
			else
			{
				fdate = frm.fromdate.value;
				fdate = new Date(fdate.substr(0,4), parseInt(fdate.substr(4,2), 10)-1, fdate.substr(6,2));
			}
		}
		
		if (frm.todate.value != null && frm.todate.value != '')
		{
			frm.todate.value = autoFillDate(frm.todate.value);
			if (!Dates.isDate(frm.todate.value, 'yyyyMMdd'))
			{
				Wizard.setInputStatus('displayInterval', 'Not a valid to-date', 'invalid');
				return;
			}
			else
			{
				tdate = frm.todate.value;
				tdate = new Date(tdate.substr(0,4), parseInt(tdate.substr(4,2), 10)-1, tdate.substr(6,2));
			}
		}
		
		if (tdate != null && fdate != null)
		{
			if (fdate > tdate)
			{
				Wizard.setInputStatus('displayInterval', 'Invalid period', 'invalid')
				return;
			}			
		}
		intervalIsValid = true;
	}
	
	labenvdbstat.submit = function(event)
	{
		var frm = document.forms['labenv'];
		var reportType = frm.reporttype.value;		
		
		var url = '../LabEnvironmentStatistics.servlet?ID='+App.getSessionId();
		url += '&cmd='+reportType;
		url += '&fdate='+encodeURIComponent(frm.fromdate.value);
		url += '&ftime='+encodeURIComponent(frm.fromtime.value);
		url += '&tdate='+encodeURIComponent(frm.todate.value);
		url += '&ttime='+encodeURIComponent(frm.totime.value);
		url += '&weekdayfilter='+encodeURIComponent(frm.weekdayfilter.value);
		if (reportType == 'labenvironmentweeklydistribution')
		{
			url += '&filterfromtime='+encodeURIComponent(frm.filterfromtime.value);
			url += '&filtertotime='+encodeURIComponent(frm.filtertotime.value);
		}
		url += '&cvariant='+encodeURIComponent(frm.chartvariant.value);
		
		Wizard.showLoadingAnimation('Generating plots...');
		Wizard.asyncJsonRequest(url, labenvdbstat.onPlotGenerated);
	}

	labenvdbstat.onPlotGenerated = function(response)
	{
		//alert("labenvironmentdatabasestatistics.js::onPlotGenerated(): response = " + response);
		if (response.status != 'ok')
		{
			setFatalError(response.message);
			return false;
		}
		var report = response.report;
		var permissionDeniedForPatientName = report.permissionDeniedForPatientName;
		var frm = document.forms['labenv'];		
		var reportType = frm.reporttype.value;
		//alert("labenvironmentdatabasestatistics.js::onPlotGenerated(): reportType = " + reportType);
		var reportTable;
		var cellElement = document.getElementById('reportdiv');
		
		if (report != null)
		{
			if (reportType == 'labenvironmentdailydistribution' || reportType == 'labenvironmentweeklydistribution')
			{
				//alert("onPlotGenerated(): Inside plot block for labenvironmentdailydistribution");
				var draw_area_wdt = 700;
				var draw_area_hgt = 550;
				var draw_scale_factor = 2;
				var jsonStatisticsPlotArray = report.plotStatistics;
				// Draw plots
				document.getElementById("reportdiv").innerHTML = "";
				for (var plotIndex in jsonStatisticsPlotArray)
				{
					//
					// Get plot JSON data container with extra info and plot data
					var plotJsonDataContainer = jsonStatisticsPlotArray[plotIndex];
					// Get plot JSON extra info and plot data
					var plotChartVariant = plotJsonDataContainer['chartVariant'];
					var plotViewType = plotJsonDataContainer['viewType'];
					var plotOptionalHeadline = plotJsonDataContainer['optionalHeadline'];
					var boxPlotJsonData = plotJsonDataContainer['plotData'];
					// Create plot from plot JSON data
					if (plotOptionalHeadline != null && plotOptionalHeadline != '')
					{
						// Print optional headline
						var headlineText = document.createElement('text');
						headlineText.innerHTML = "<BR>" + plotOptionalHeadline + "<BR>";
						cellElement.appendChild(headlineText);
					}
					var plotKey = plotChartVariant + '_' + plotViewType;
					// Add plot
					var canvasInTable = document.createElement('canvas');
					canvasInTable.setAttribute('id', plotKey);
					canvasInTable.setAttribute('width', draw_area_wdt * draw_scale_factor);
					canvasInTable.setAttribute('height', draw_area_hgt * draw_scale_factor);
					//alert("onPlotGenerated(): Calling createBoxPlot()");
					createBoxPlot(boxPlotJsonData, canvasInTable, draw_area_wdt, draw_area_hgt, draw_scale_factor);
					cellElement.appendChild(canvasInTable);					
					canvasInTable.addEventListener('mousemove', labenvdbstat.drawCanvasGuidelines, false);
					canvasInTable.addEventListener('mouseleave', labenvdbstat.hideCanvasGuidelines, false);
				}
				// Print optional appended info
				var appendedInfo = report.appendedInfo;
				if (appendedInfo != null && appendedInfo != '')
				{
					// Print optional headline
					var infoText = document.createElement('text');
					infoText.innerHTML = "<BR>" + appendedInfo + "<BR>";
					cellElement.appendChild(infoText);
				}
			}
		}
		else
		{
			var messageCell = labenvdbstat.getTableCellElement('No values could be found during given period', 'reportheader');
			var messageRow = document.createElement('tr');
			messageRow.appendChild(messageCell);			
			var messageTable = labenvdbstat.getReportTable();
			messageTable.appendChild(messageRow);
			reportTable = messageTable;			
		}
		Doc.show('step-3');
		Doc.show('printButton');
		Doc.show('gorestart');		
	}

	labenvdbstat.getReportTable = function()
	{
			var reportTable = document.createElement('table');
			reportTable.setAttribute('class','reporttable');
			reportTable.setAttribute('border','1');			
			return reportTable;
	}
	
	labenvdbstat.getTableCellElement = function(text, clazz, colspan, rowspan)
	{
		var cellElement = document.createElement('td');
		text = new String(text);		
		var textArray = text.split("\n");		
		if (textArray.length > 1)
		{	
			for (var i=0;i<textArray.length;i++)
			{				
				if (i>0)cellElement.appendChild(document.createElement('br'));
				cellElement.appendChild(document.createTextNode(textArray[i]));
			}			
		}
		else
		{
			cellElement.appendChild(document.createTextNode(text));
		}
		cellElement.setAttribute('class', clazz);
		if (colspan != null) cellElement.setAttribute('colspan', colspan);
		if (rowspan != null) cellElement.setAttribute('rowspan', rowspan);
		
		return cellElement;
	}
	
	var xGuide;
	var yGuide;
	
	labenvdbstat.drawCanvasGuidelines = function(event)
	{
		if (!xGuide)
		{
			xGuide = document.getElementById('x-guide');
			yGuide = document.getElementById('y-guide');
		}
		var canvas = event.target;
		var centerX = event.clientX;
		var centerY = event.clientY;
		var canvasPos = Doc.getElementPosition(canvas);
		var startX = canvasPos.left+50;
		var widthX = canvasPos.width-100;
		var startY = canvasPos.top+80;
		var heightY = canvasPos.height-160;
		if (centerY < startY || centerY > startY+heightY)
		{
			// Hide when mouse is in the text area below or over the plot
			yGuide.style.display = 'none';
		}
		else
		{
			yGuide.style.top = (centerY-2) + 'px';
			yGuide.style.left = startX + 'px';
			yGuide.style.width = widthX + 'px';
			yGuide.style.display = 'block';
		}
		if (centerX < startX || centerX > startX + widthX)
		{
			// Hide when mouse is in the text area to the left or right of the plot
			xGuide.style.display = 'none';
		}
		else
		{
			// Avoid drawing outside the avilable height (causes an extra pair of scroll bars)
			var yLimit = App.getWindowPosition().height;
			if (startY+heightY > yLimit)
			{
				heightY = yLimit-startY;
			}
			xGuide.style.top = startY + 'px';
			xGuide.style.left = (centerX-2) + 'px';
			xGuide.style.height = heightY + 'px';
			xGuide.style.display = 'block';
		}
	}
	
	labenvdbstat.hideCanvasGuidelines = function(event)
	{
		xGuide.style.display = 'none';
		yGuide.style.display = 'none';
	}
	
	labenvdbstat.printVersion = function()
	{
		var printNote = '<b>Note!</b> For better printing set page orientation to <i>portrait</i>.';
		printNote += ' Scale down to <i>90%</i> to fit 2 plots per page.';
		Reggie.openPrintWindow('step-3-content', 'Lab environment statistics', 'portrait', printNote, '../', 'report.css');
	}
	
	return labenvdbstat;
}();

Doc.onLoad(LabEnvDbStat.initPage);
