var LabSensInf = function()
{
	var labsensinf = {};
	var debug = 1;

	// Page initialization
	labsensinf.initPage = function()
	{
		previewTitle = Doc.element('previewTitle');
		previewList = Doc.element('previewList');

		// Step 1

		// Navigation
		Buttons.addClickHandler('goexport', labsensinf.goExport);
		Buttons.addClickHandler('gopreview', labsensinf.goPreview);

		// Create lab sensor menu from configuration data
		labsensinf.createSensorMenu();

		Doc.show('step-1');
		Doc.show('gopreview');
		Doc.show('goexport');
	}

	labsensinf.createSensorMenu = function()
	{
		// Get lab sensor configurations JSON object with AJAX
		var url = '../LabEnvironment.servlet?ID='+App.getSessionId();
		url += '&cmd=GetLabSensorConfigList';

		Wizard.asyncJsonRequest(url, labsensinf.createSensorMenu2);
	}

	labsensinf.createSensorMenu2 = function(response)
	{
		Doc.show('navigation');
		if (response.status != 'ok')
		{
			setFatalError(response.message);
			return false;
		}
		// Get sensor configurations information from the AJAX response
		var labSensorConfigList = response.labSensorConfigList;
		if (labSensorConfigList != null)
		{
			// Construct lab sensor menu from JSON data
			var sensorSelect = document.getElementById('sensorSelectId');
			for (var i=0; i < labSensorConfigList.length; i++)
			{
				// Get URL and name for lab sensor number 'i'
				var labSensorConfig = labSensorConfigList[i];
				var sensorUrl = labSensorConfig['url'];
				var sensorName = labSensorConfig['name'];
				// Create and add new option element to select menu
				var optionEl = document.createElement('option');
				optionEl.setAttribute('value',sensorUrl);
				optionEl.innerHTML = sensorName;
				sensorSelect.appendChild(optionEl);
			}
		}
	}

	labsensinf.goPreview = function()
	{
		labsensinf.doExport(true);
	}

	labsensinf.goExport = function()
	{
		labsensinf.doExport(false);
	}

	labsensinf.doExport = function(preview)
	{
		var frm = document.forms['labenv'];
		var url = '../LabEnvironment.servlet?ID='+App.getSessionId();
		url += '&cmd=LabEnvironmentSensorQuery';
		if (frm.sensorSelect.value != null) url += '&sensorurl='+frm.sensorSelect.value;
		var sensorUrlText = frm.sensorSelect[frm.sensorSelect.selectedIndex].text;
		url += '&sensorname='+sensorUrlText;
		if (preview) 
		{
			Doc.hide('previewWrapper');
			var previewTitle = document.getElementById('previewTitle');
			var previewList = document.getElementById('previewList');
		
			Doc.hide('previewWrapper');
			previewTitle.innerHTML = 'Working...';
			previewList.innerHTML = '';
		
			url += '&preview=1';

			Wizard.showLoadingAnimation('Working...');
			Doc.hide('navigation');
			Wizard.asyncJsonRequest(url, labsensinf.onPreviewLoaded);
		}
		else
		{
			window.location = url;		
		}	
	}

	labsensinf.onPreviewLoaded = function(response)
	{
		Doc.show('navigation');
		var frm = document.forms['labenv'];
		var allLines = response.split('\n');
		var numLines = allLines.length - 2; // First line is a header line
		
		var html = '<tr><th>'+allLines[0].replace(/\t/g, '</th><th>')+'</th></tr>';
		for (var i = 1 ; i <= numLines; i++)
		{
			var line = allLines[i];
			var cols = line.split(/\t/);
			var rowClass = '';
			html += '<tr class="'+rowClass+'"><td>'+cols.join('</td><td>')+'</td></tr>';
		}

		var sensorUrlText = frm.sensorSelect[frm.sensorSelect.selectedIndex].text;
		previewTitle.innerHTML = 'Sensor - ' + sensorUrlText;
		previewList.innerHTML = '<table>'+html+'</table>';
		Doc.show('previewWrapper');
	}

	labsensinf.addEventHandlers = function(elements, eventName, handler)
	{
		for (var i = 0; i < elements.length; i++)
		{
			Events.addEventHandler(elements[i], eventName, handler);
		}
	}
	
	return labsensinf;
}();

Doc.onLoad(LabSensInf.initPage);
